------------------------------------------------------------------------
-- Casts do not change the semantics of things
------------------------------------------------------------------------

-- # import Explicit
-- # import Implicit.Terms
-- # import Implicit.Substitutions
-- # import Implicit.Equality
-- # import Implicit.Equivalence
-- # import Implicit.EqualityLemmas
-- # import EqKind
-- # import TmVar

abstract

  castTm⁻TmVarEq (k : EqKind) (tv¹, tv² : TmVar)
                   (Γ : Ctxt) (τ : Ty Γ) (t : Γ ⊢ τ)
    :  (eqtv : tv¹ ≡ tv²) -> (t⁻ : Tm⁻ tv¹ t)
    -> Tm⁻Eq k (castTm⁻TmVar eqtv t⁻) t⁻
  castTm⁻TmVarEq refl t⁻ = reflTm⁻ t⁻

  castSubst⁻TmVarEq (k : EqKind) (tv¹, tv² : TmVar)
                    (Γ, Δ : Ctxt) (ρ : Subst Γ Δ)
    :  (eqtv : tv¹ ≡ tv²) -> (ρ⁻ : Subst⁻ tv¹ ρ)
    -> Subst⁻Eq k (castSubst⁻TmVar eqtv ρ⁻) ρ⁻
  castSubst⁻TmVarEq refl ρ⁻ = reflSubst⁻ ρ⁻

  castTm⁻CtxtEq (k : EqKind) (tv : TmVar)
                (Γ¹, Γ² : Ctxt) (τ : Ty Γ¹) (t : Γ¹ ⊢ τ)
    :  (t⁻ : Tm⁻ tv t) -> (eqΓ : Γ¹ ≜ Γ²)
    -> Tm⁻Eq k t⁻ (castTm⁻Ctxt t⁻ eqΓ)
  castTm⁻CtxtEq (var⁻ _ v) eqΓ = castTm⁻Eqʳ _ $
    var⁻Cong $ castVarCtxtEq v eqΓ
  castTm⁻CtxtEq (λ⁻ _ t) eqΓ = castTm⁻Eqʳ _ $
    λ⁻Cong $ castTm⁻CtxtEq t (eqΓ ▻Cong castTyEq _ eqΓ)
  castTm⁻CtxtEq (t₁ @⁻ t₂) eqΓ = castTm⁻Eqʳ _ $
    app⁻Cong (castTm⁻CtxtEq t₁ eqΓ) (castTm⁻CtxtEq t₂ eqΓ)
  castTm⁻CtxtEq (t ∷≡⊢⁻ eqt) eqΓ = castTm⁻Cong _ _ $ castTm⁻CtxtEq t eqΓ

  generalCastTm⁻Eq (k : EqKind) (tv : TmVar)
                   (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹)
                   (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²)
    : (t⁻ : Tm⁻ tv t¹) -> (eqt : t¹ ≈⊢ t²) -> Tm⁻Eq k t⁻ (t⁻ ∷⊢⁻ eqt)
  generalCastTm⁻Eq t eqt = castTm⁻Eqʳ _ $ castTm⁻CtxtEq t _

  generalCastSubst⁻Eq (k : EqKind) (tv : TmVar)
    (Γ¹, Δ¹ : Ctxt) (ρ¹ : Subst Γ¹ Δ¹)
    (Γ², Δ² : Ctxt) (ρ² : Subst Γ² Δ²)
    :  (ρ⁻ : Subst⁻ tv ρ¹) -> (eqρ : ρ¹ ≘ ρ²)
    -> Subst⁻Eq k ρ⁻ (ρ⁻ ∷⇒⁻ eqρ)
  generalCastSubst⁻Eq (∅⁻ tv Δ) (emptyCong eqΔ) =
    castSubst⁻Eqʳ _ $ ∅⁻Cong tv tv eqΔ
  generalCastSubst⁻Eq (ρ ▷⁻ t⁻) (snocCong eqρ eqτ eqt) =
    castSubst⁻Eqʳ _ $
      Cong▷⁻ (generalCastSubst⁻Eq ρ _)
             eqτ
             (generalCastTm⁻Eq t⁻ _)
  generalCastSubst⁻Eq (ρ ∷≡⇒⁻ eqρ₁) eqρ₂ =
    castSubst⁻Eqˡ _ $ generalCastSubst⁻Eq ρ _

Implicit-CastEq : Type
Implicit-CastEq = time-plugin(Implicit-CastEq, Set)
