------------------------------------------------------------------------
-- Missing bits and pieces
------------------------------------------------------------------------

-- Many of these lemmas could (probably) be proved a lot easier if
-- substEqSubst⁻Eq could give structural proofs.

-- # import Explicit
-- # import Implicit.Terms
-- # import Implicit.Substitutions
-- # import Implicit.Equality
-- # import Implicit.SubstitutionLemmas
-- # import Implicit.Completeness
-- # import EqKind
-- # import TmVar

------------------------------------------------------------------------
-- A substitution and a related lemma

abstract

  generalisedId⁻ (Γ, Δ : Ctxt)
    : (tv : TmVar) -> (eqΓ : Γ ≜ Δ) -> Subst⁻ tv (generalisedId eqΓ)
  generalisedId⁻ {Γ} tv eqΓ = id⁻ tv Γ ∷⇒⁻ lemma
    where
    lemma : id Γ ≘ generalisedId eqΓ
    lemma = symSubst $ generalisedIdIsId eqΓ

  generalisedId⁻IsId⁻ (Γ, Δ : Ctxt) (k : EqKind)
    :  (tv : TmVar) -> (eqΓ : Γ ≜ Δ)
    -> Subst⁻Eq k (generalisedId⁻ tv eqΓ) (id⁻ tv Γ)
  generalisedId⁻IsId⁻ {Γ} tv eqΓ =
    symSubst⁻ (generalCastSubst⁻Eq (id⁻ tv Γ) _)

------------------------------------------------------------------------
-- More substitution lemmas

abstract

  lift⁻Cong (k : EqKind)
            (tv¹ : TmVar) (Γ¹, Δ¹ : Ctxt)
            (ρ¹ : Subst Γ¹ Δ¹) (ρ⁻¹ : Subst⁻ tv¹ ρ¹) (σ¹ : Ty Γ¹)
            (tv² : TmVar) (Γ², Δ² : Ctxt)
            (ρ² : Subst Γ² Δ²) (ρ⁻² : Subst⁻ tv² ρ²) (σ² : Ty Γ²)
    :  Subst⁻Eq k ρ⁻¹ ρ⁻² -> σ¹ ≛ σ²
    -> Subst⁻Eq k (ρ⁻¹ ↑⁻ σ¹) (ρ⁻² ↑⁻ σ²)
  lift⁻Cong {k} {tv¹} {Γ¹} {Δ¹} {ρ¹} {ρ⁻¹} {σ¹} {tv²} =
    lift⁻'Cong (weakCong₁₂₁ tv¹ tv²)

  id⁻Cong (k : EqKind)
          (tv¹ : TmVar) (Γ¹ : Ctxt)
          (tv² : TmVar) (Γ² : Ctxt)
    :  Γ¹ ≜ Γ² -> Subst⁻Eq k (id⁻ tv¹ Γ¹) (id⁻ tv² Γ²)
  id⁻Cong {_} {tv¹} {_} {tv²} = id⁻'Cong (weakCong₁₂₁ tv¹ tv²)

  comp⁻Cong (k : EqKind)
    (Γ¹, Δ¹, X¹ : Ctxt) (ρ₁¹ : Subst Γ¹ Δ¹) (ρ₂¹ : Subst Δ¹ X¹)
    (tv₁¹, tv₂¹ : TmVar)
    (ρ⁻₁¹ : Subst⁻ tv₁¹ ρ₁¹) (ρ⁻₂¹ : Subst⁻ tv₂¹ ρ₂¹)
    (Γ², Δ², X² : Ctxt) (ρ₁² : Subst Γ² Δ²) (ρ₂² : Subst Δ² X²)
    (tv₁², tv₂² : TmVar)
    (ρ⁻₁² : Subst⁻ tv₁² ρ₁²) (ρ⁻₂² : Subst⁻ tv₂² ρ₂²)
    :  Subst⁻Eq k ρ⁻₁¹ ρ⁻₁² -> Subst⁻Eq k ρ⁻₂¹ ρ⁻₂²
    -> Subst⁻Eq k (ρ⁻₁¹ ⊙⁻ ρ⁻₂¹) (ρ⁻₁² ⊙⁻ ρ⁻₂²)
  comp⁻Cong eqρ₁ eqρ₂ =
    extEq⁻ (subst⁻EqCtxtEqLeft eqρ₁) (subst⁻EqCtxtEqRight eqρ₂) $
      \_ v¹ _ v² eqv ->
         betweenTm⁻ (compSplitsVar⁻ v¹ _ _) (compSplitsVar⁻ v² _ _) $
           substTm⁻Cong (substVar⁻Cong eqv eqρ₁) eqρ₂

  compLiftIsComp⁻ (k : EqKind) (tv₁, tv₂ : TmVar)
                  (Γ, Δ, X : Ctxt) (ρ₁ : Subst Γ Δ) (ρ₂ : Subst Δ X)
    :  (ρ⁻₁ : Subst⁻ tv₁ ρ₁) -> (ρ⁻₂ : Subst⁻ tv₂ ρ₂) -> (σ : Ty Γ)
    -> Subst⁻Eq k (ρ⁻₁ ⊙⁻ ρ⁻₂ ↑⁻ σ) ((ρ⁻₁ ↑⁻ σ) ⊙⁻ (ρ⁻₂ ↑⁻ (σ / ρ₁)))
  compLiftIsComp⁻ ρ⁻₁ ρ⁻₂ σ =
    extEq⁻ˡ⁼ (ρ⁻₁ ⊙⁻ ρ⁻₂ ↑⁻ σ) ((ρ⁻₁ ↑⁻ σ) ⊙⁻ (ρ⁻₂ ↑⁻ (σ / _)))
             (reflCtxt _ ▻Cong compSplitsTy σ _ _) $ \τ v ->
      compSplitsTm⁻ʳ _ _ (singletonʳ σ) _ _ (var⁻ Var v) ρ⁻₁ ρ⁻₂
        `transTm⁻`
      symTm⁻ (compSplitsTm⁻ (var⁻ Var v) (ρ⁻₁ ↑⁻ σ) (ρ⁻₂ ↑⁻ (σ / _)))

------------------------------------------------------------------------
-- Another substitution with some lemmas

wk⋆⁻ (Γ : Ctxt) : (tv : TmVar) -> (Γ' : RCtxt Γ) -> Subst⁻ tv (wk⋆ Γ')
wk⋆⁻ tv (εʳ Γ)    = id⁻ tv Γ
wk⋆⁻ tv (Γ' ▻ʳ σ) =
  castSubst⁻TmVar (idempotent⊔ tv) $
    wk⋆⁻ tv Γ' ⊙⁻ wk⁻ tv σ

abstract

  wk⋆⁻Splits (k : EqKind) (Γ : Ctxt)
    :  (tv : TmVar) -> (Γ' : RCtxt Γ) -> (σ : Ty (Γ ++ Γ'))
    -> Subst⁻Eq k (wk⋆⁻ tv (Γ' ▻ʳ σ)) (wk⋆⁻ tv Γ' ⊙⁻ wk⁻ tv σ)
  wk⋆⁻Splits tv Γ' σ = castSubst⁻TmVarEq _ _

  wk⋆⁻Cong (k : EqKind)
           (tv¹ : TmVar) (Γ¹ : Ctxt) (Γ'¹ : RCtxt Γ¹)
           (tv² : TmVar) (Γ² : Ctxt) (Γ'² : RCtxt Γ²)
    : Γ'¹ ≜→ Γ'² -> Subst⁻Eq k (wk⋆⁻ tv¹ Γ'¹) (wk⋆⁻ tv² Γ'²)
  wk⋆⁻Cong (εʳCong eqΓ)      = id⁻Cong eqΓ
  wk⋆⁻Cong (eqΓ' ▻ʳCong eqσ) =
    betweenSubst⁻ (castSubst⁻TmVarEq _ _) (castSubst⁻TmVarEq _ _) $
      comp⁻Cong (wk⋆⁻Cong eqΓ') (wk⁻Cong eqσ)

------------------------------------------------------------------------
-- Some lemmas about tm⁻ToVar

abstract

  tm⁻ToVarEq⁻ (k : EqKind)
              (Γ : Ctxt) (τ : Ty Γ) (t : Γ ⊢ τ)
    : (t⁻ : Tm⁻ Var t) -> Tm⁻Eq k (var⁻ Var (tm⁻ToVar t⁻)) t⁻
  tm⁻ToVarEq⁻ (var⁻ _ v)    = var⁻Cong $ reflVar v
  tm⁻ToVarEq⁻ (t⁻ ∷≡⊢⁻ eqt) =
    betweenTm⁻ (var⁻Cong $ castVarEq _ _) (castTm⁻Eq _ _) $
      tm⁻ToVarEq⁻ t⁻

  tm⁻ToVarSubstLemma (k : EqKind) (tv : TmVar)
    (Γ, Δ : Ctxt) (τ : Ty Γ) (t : Γ ⊢ τ) (ρ : Subst Γ Δ)
    :  (t⁻ : Tm⁻ Var t) -> (ρ⁻ : Subst⁻ tv ρ)
    -> Tm⁻Eq k (tm⁻ToVar t⁻ /∋⁻ ρ⁻) (t⁻ /⊢⁻ ρ⁻)
  tm⁻ToVarSubstLemma t⁻ ρ⁻ =
    substTm⁻Cong (tm⁻ToVarEq⁻ t⁻) (reflSubst⁻ ρ⁻)

Implicit-Misc : Type
Implicit-Misc = time-plugin(Implicit-Misc, Set)
