------------------------------------------------------------------------
-- Substitution lemmas
------------------------------------------------------------------------

-- The goal of this "module" is to provide the necessary lemmas so
-- that we can prove completeness.

-- These proofs take up a lot of space, so I have divided this module
-- into several parts:

-- I)    The goal of this part is to prove weakCongˢ/substTm⁻Congˢ
--       (these lemmas do not accept the β and η axioms in their input
--       equalities).

--       Note that several lemmas in this part are parameterised on a
--       WeakeningCong. After weakCongˢ has been proved no more such
--       lemmas need to be introduced, except for substTm⁻'Cong. Hence
--       one goal is to minimise the number of such lemmas.

-- II)   Simple substitution application (/) lemmas.

-- III)  Here idVanishesTm⁻ is proved.

-- IV)   Ditto for compSplitsTm⁻.

-- V)    Substitution lemmas: sub⁻Commutes and wkSubVanishes⁻.
--       (wk⁻Commutes is proved in a previous section and used in the
--       proof of compSplitsTm⁻.)

-- VI)   In this part weakCongˢ/substTm⁻Congˢ are generalised to
--       weakCong/substTm⁻Cong (which accept arbitrary equalities as
--       input).

-- VII)  More substitution lemmas.

-- # import Implicit.SubstitutionLemmas.StructuralCong
-- # import Implicit.SubstitutionLemmas.SimpleLemmas
-- # import Implicit.SubstitutionLemmas.IdVanishes
-- # import Implicit.SubstitutionLemmas.CompSplits
-- # import Implicit.SubstitutionLemmas.SubLemmas
-- # import Implicit.SubstitutionLemmas.BetaEtaCong
-- # import Implicit.SubstitutionLemmas.MoreLemmas

Implicit-SubstitutionLemmas : Type
Implicit-SubstitutionLemmas =
  time-plugin(Implicit-SubstitutionLemmas, Set)
