------------------------------------------------------------------------
-- weakCong/substTm⁻Cong
------------------------------------------------------------------------

-- # import Explicit
-- # import Implicit.Terms
-- # import Implicit.Substitutions
-- # import Implicit.FromExplicit
-- # import Implicit.Equality
-- # import Implicit.Equivalence
-- # import Implicit.EqualityLemmas
-- # import Implicit.CastEq
-- # import Implicit.WeakeningCong
-- # import Implicit.Coercions
-- # import Implicit.Soundness
-- # import Implicit.SubstitutionLemmas.StructuralCong
-- # import Implicit.SubstitutionLemmas.SimpleLemmas
-- # import Implicit.SubstitutionLemmas.IdVanishes
-- # import Implicit.SubstitutionLemmas.CompSplits
-- # import Implicit.SubstitutionLemmas.SubLemmas
-- # import EqKind
-- # import TmVar

abstract

  substTm⁻'β (k : EqKind) (tv₁, tv₂ : TmVar)
             (Γ : Ctxt) (τ₁ : Ty Γ) (τ₂ : Ty (Γ ▻ τ₁))
             (τ⁻₁ : Ty⁻ τ₁) (t₁ : Γ ▻ τ₁ ⊢ τ₂) (t₂ : Γ ⊢ τ₁)
             (tv¹ : TmVar) (Δ¹ : Ctxt)
             (ρ¹ : Subst Γ Δ¹) (ρ⁻¹ : Subst⁻ tv¹ ρ¹)
             (tv² : TmVar) (Δ² : Ctxt)
             (ρ² : Subst Γ Δ²) (ρ⁻² : Subst⁻ tv² ρ²)
    :  WeakeningCong₁₂₁ k (weak tv¹) (weak tv²)
    -> (t⁻₁ : Tm⁻ tv₁ t₁) -> (t⁻₂ : Tm⁻ tv₂ t₂) -> Subst⁻Eq k ρ⁻¹ ρ⁻²
    -> λ⁻ τ⁻₁ t⁻₁ @⁻ t⁻₂ /⊢⁻ ρ⁻¹ ≈⊢⁻ t⁻₁ /⊢⁻ sub⁻ t⁻₂ /⊢⁻ ρ⁻²
  substTm⁻'β wCong t⁻₁ t⁻₂ eqρ⁻ =
    castTm⁻Eq _ _ `transTm⁻` app⁻Cong (castTm⁻Eq _ _) (reflTm⁻ _)
      `transTm⁻`
    β⁻ (t⁻₁ /⊢⁻ _ ↑⁻ _) (t⁻₂ /⊢⁻ _)
      `transTm⁻`
    symTm⁻ (sub⁻CommutesTm⁻ t⁻₁ t⁻₂ _)
      `transTm⁻`
    coerceToTm⁻ (substTm⁻'Congˢ wCong (reflTm⁻ _) eqρ⁻)

  substTm⁻'η (k : EqKind) (tv₁, tv₂, tv₃ : TmVar) (Γ : Ctxt)
             (τ₁ : Ty Γ) (τ₂ : Ty (Γ ▻ τ₁)) (τ⁻₁ : Ty⁻ τ₁)
             (t : Γ ⊢ Π τ₁ τ₂)
             (tv¹ : TmVar) (Δ¹ : Ctxt)
             (ρ¹ : Subst Γ Δ¹) (ρ⁻¹ : Subst⁻ tv¹ ρ¹)
             (tv² : TmVar) (Δ² : Ctxt)
             (ρ² : Subst Γ Δ²) (ρ⁻² : Subst⁻ tv² ρ²)
    :  WeakeningCong₁₂₁ k (weak tv¹) (weak tv²)
    -> (t⁻ : Tm⁻ tv₁ t) -> Subst⁻Eq k ρ⁻¹ ρ⁻²
    -> λ⁻ τ⁻₁ ((t⁻ /⊢⁻ wk⁻ tv₂ τ₁) @⁻ var⁻ tv₃ (vz τ₁)) /⊢⁻ ρ⁻¹ ≈⊢⁻
       t⁻ /⊢⁻ ρ⁻²
  substTm⁻'η {k} {tv₁} {tv₂} {tv₃} {Γ} {τ₁} {τ₂} {τ⁻₁} {t}
             {tv¹} {Δ¹} {ρ¹} {ρ⁻¹} {tv²} {Δ²} {ρ²} {ρ⁻²}
             wCong t⁻ eqρ⁻ =
    castTm⁻Eq _ _ `transTm⁻` λ⁻Cong (castTm⁻Eq _ _)
      `transTm⁻`
    λ⁻Cong {_} {_} {_} {_} {_} {_} {tyToTy⁻ _}
      (app⁻Cong (wk⁻CommutesTm⁻ t⁻ tv₂ τ₁ ρ⁻¹) (subst⁻VzLift _ τ₁ ρ⁻¹))
      `transTm⁻`
    η⁻ {_} {_} {_} {_} {_} {_} {_} {tyToTy⁻ _} (t⁻ /⊢⁻ ρ⁻¹)
      `transTm⁻`
    coerceToTm⁻ (substTm⁻'Congˢ wCong (reflTm⁻ t⁻) eqρ⁻)

  substTm⁻'Cong (k₁, k₂ : EqKind)
                (Γ¹, Δ¹ : Ctxt) (τ¹ : Ty Γ¹)
                (ρ¹ : Subst Γ¹ Δ¹) (t¹ : Γ¹ ⊢ τ¹) (tv₁¹, tv₂¹ : TmVar)
                (t⁻¹ : Tm⁻ tv₁¹ t¹) (ρ⁻¹ : Subst⁻ tv₂¹ ρ¹)
                (Γ², Δ² : Ctxt) (τ² : Ty Γ²)
                (ρ² : Subst Γ² Δ²) (t² : Γ² ⊢ τ²) (tv₁², tv₂² : TmVar)
                (t⁻² : Tm⁻ tv₁² t²) (ρ⁻² : Subst⁻ tv₂² ρ²)
    :  WeakeningCong₁₂₁ k₂ (weak tv₂¹) (weak tv₂²)
    -> Tm⁻Eq k₁ t⁻¹ t⁻² -> Subst⁻Eq k₂ ρ⁻¹ ρ⁻²
    -> Tm⁻Eq (k₁ ∨ k₂) (t⁻¹ /⊢⁻ ρ⁻¹) (t⁻² /⊢⁻ ρ⁻²)
  substTm⁻'Cong wCong (var⁻Cong eqv) eqρ = coerceTo∨Tm⁻ $
    Tm⁻⊔Cong _ _ (substVar⁻Cong eqv eqρ)
    where
    coerceTo∨Tm⁻ (k₁, k₂ : EqKind)
                 (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹)
                 (tv¹ : TmVar) (t⁻¹ : Tm⁻ tv¹ t¹)
                 (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²)
                 (tv² : TmVar) (t⁻² : Tm⁻ tv² t²)
      : Tm⁻Eq k₂ t⁻¹ t⁻² -> Tm⁻Eq (k₁ ∨ k₂) t⁻¹ t⁻²
    coerceTo∨Tm⁻ {structural} eqt = eqt
    coerceTo∨Tm⁻ {βη}         eqt = coerceToTm⁻ eqt
  substTm⁻'Cong wCong (λ⁻Cong eqt) eqρ =
    castTm⁻Cong _ _ $ λ⁻Cong $
      substTm⁻'Cong wCong eqt (lift⁻'Cong wCong eqρ eqτ₁)
    where eqτ₁ = snocEqLastEq $ tm⁻EqCtxtEq eqt
  substTm⁻'Cong wCong (app⁻Cong eqt₁ eqt₂) eqρ =
    castTm⁻Cong _ _ (app⁻Cong (substTm⁻'Cong wCong eqt₁ eqρ)
                              (substTm⁻'Cong wCong eqt₂ eqρ))
  substTm⁻'Cong wCong (castTm⁻Eqˡ eqt eqt⁻) eqρ =
    castTm⁻Eqˡ _ $ substTm⁻'Cong wCong eqt⁻ eqρ
  substTm⁻'Cong wCong (castTm⁻Eqʳ eqt eqt⁻) eqρ =
    castTm⁻Eqʳ _ $ substTm⁻'Cong wCong eqt⁻ eqρ
  substTm⁻'Cong wCong (symTm⁻βη eqt⁻²¹) eqρ⁻¹² =
    symTm⁻ (substTm⁻'Cong wCong' eqt⁻²¹ eqρ⁻²¹)
    where
    wCong' = swapWCong₁₂₁ wCong
    eqρ⁻²¹ = symSubst⁻ eqρ⁻¹²
  substTm⁻'Cong {_} {k₂} {_} {_} {_} {ρ¹} {_} {_} {_} {_} {ρ⁻¹}
                wCong (transTm⁻βη eqt⁻¹² eqt⁻²³) eqρ⁻¹³ =
    transTm⁻ (substTm⁻'Cong wCong¹² eqt⁻¹² eqρ⁻¹²)
             (substTm⁻'Cong wCong²³ eqt⁻²³ eqρ⁻²³)
    where
    wCong¹² = wCong₁₂₁To₁₁₁ wCong
    wCong²³ = wCong
    eqΓ¹²   = tm⁻EqCtxtEq eqt⁻¹²
    eqρ¹²   = castSubstˡEq ρ¹ eqΓ¹²
    eqρ⁻¹²  = generalCastSubst⁻Eq {k₂} ρ⁻¹ eqρ¹²
    eqρ⁻²³  = symSubst⁻ eqρ⁻¹² `transSubst⁻` eqρ⁻¹³
  substTm⁻'Cong wCong (β⁻ t⁻₁ t⁻₂) eqρ⁻ =
    substTm⁻'β wCong t⁻₁ t⁻₂ eqρ⁻
  substTm⁻'Cong wCong (η⁻ t⁻) eqρ⁻ =
    substTm⁻'η wCong t⁻ eqρ⁻

  weakCong (k : EqKind)
    :  (tv¹, tv² : TmVar)
    -> WeakeningCong k (weak tv¹) (weak tv²)
  weakCong {k} =
    weakCong' $ \_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ eqt eqρ ->
      rewrite-plugin(sym $ structuralRightUnit k,
        substTm⁻'Cong weakVarCongˢ₁₂₁ eqt eqρ)

  weakCong₁₂₁ (k : EqKind)
    : (tv¹, tv² : TmVar) -> WeakeningCong₁₂₁ k (weak tv¹) (weak tv²)
  weakCong₁₂₁ tv¹ tv² =
    weakeningCong₁₂₁ (weakCong tv¹ tv¹)
                     (weakCong tv¹ tv²)
                     (weakCong tv² tv²)

  substTm⁻Cong (k : EqKind)
               (Γ¹, Δ¹ : Ctxt) (τ¹ : Ty Γ¹)
               (ρ¹ : Subst Γ¹ Δ¹) (t¹ : Γ¹ ⊢ τ¹) (tv₁¹, tv₂¹ : TmVar)
               (t⁻¹ : Tm⁻ tv₁¹ t¹) (ρ⁻¹ : Subst⁻ tv₂¹ ρ¹)
               (Γ², Δ² : Ctxt) (τ² : Ty Γ²)
               (ρ² : Subst Γ² Δ²) (t² : Γ² ⊢ τ²) (tv₁², tv₂² : TmVar)
               (t⁻² : Tm⁻ tv₁² t²) (ρ⁻² : Subst⁻ tv₂² ρ²)
    :  Tm⁻Eq k t⁻¹ t⁻² -> Subst⁻Eq k ρ⁻¹ ρ⁻²
    -> Tm⁻Eq k (t⁻¹ /⊢⁻ ρ⁻¹) (t⁻² /⊢⁻ ρ⁻²)
  substTm⁻Cong {k} eqt eqρ =
    rewrite-plugin(sym $ idempotent∨ k,
      substTm⁻'Cong (weakCong₁₂₁ _ _) eqt eqρ)

Implicit-SubstitutionLemmas-BetaEtaCong : Type
Implicit-SubstitutionLemmas-BetaEtaCong =
  time-plugin(Implicit-SubstitutionLemmas-BetaEtaCong, Set)
