------------------------------------------------------------------------
-- Simple substitution application (/) lemmas
------------------------------------------------------------------------

-- # import Explicit
-- # import Implicit.Terms
-- # import Implicit.Substitutions
-- # import Implicit.FromExplicit
-- # import Implicit.Equality
-- # import Implicit.Equivalence
-- # import Implicit.EqualityLemmas
-- # import Implicit.CastEq
-- # import Implicit.WeakeningCong
-- # import Implicit.Coercions
-- # import Implicit.Soundness
-- # import Implicit.SubstitutionLemmas.StructuralCong
-- # import EqKind
-- # import TmVar

abstract

  wk⁻Cong (k : EqKind)
          (tv¹ : TmVar) (Γ¹ : Ctxt) (σ¹ : Ty Γ¹)
          (tv² : TmVar) (Γ² : Ctxt) (σ² : Ty Γ²)
    : σ¹ ≛ σ² -> Subst⁻Eq k (wk⁻ tv¹ σ¹) (wk⁻ tv² σ²)
  wk⁻Cong {k} {tv¹} {Γ¹} {σ¹} {tv²} eqσ = coerceFromSubst⁻ $
    wk⁻'Cong (weakCongˢ₁₂₁ tv¹ tv²) eqσ

  idVanishesVar⁻ (tv : TmVar) (k : EqKind) (Γ : Ctxt) (τ : Ty Γ)
    : (v : Γ ∋ τ) -> Tm⁻Eq k (v /∋⁻ id⁻ tv Γ) (var⁻ tv v)
  idVanishesVar⁻ {tv} v = coerceFromTm⁻ $
    idVanishesVar⁻' (weakCongˢ tv tv) v

  substVar⁻VzLift (k : EqKind) (tv : TmVar)
                  (Γ, Δ : Ctxt) (ρ : Subst Γ Δ)
    :  (σ : Ty Γ) -> (ρ⁻ : Subst⁻ tv ρ)
    -> Tm⁻Eq k (vz σ /∋⁻ ρ⁻ ↑⁻ σ) (var⁻ tv (vz $ σ / ρ))
  substVar⁻VzLift σ ρ⁻ =
    castTm⁻Eq _ _ `transTm⁻` castTm⁻Eq _ _
      `transTm⁻`
    var⁻Cong (castVarEq _ _)

  subst⁻VzLift (k : EqKind) (tv₂ : TmVar)
               (Γ, Δ : Ctxt) (ρ : Subst Γ Δ)
    :  (tv₁ : TmVar) -> (σ : Ty Γ) -> (ρ⁻ : Subst⁻ tv₂ ρ)
    -> Tm⁻Eq k (var⁻ tv₁ (vz σ) /⊢⁻ ρ⁻ ↑⁻ σ) (var⁻ tv₂ (vz $ σ / ρ))
  subst⁻VzLift tv₁ σ ρ⁻ =
    Tm⁻⊔Eq _ _
      `transTm⁻`
    substVar⁻VzLift σ ρ⁻

  substVar⁻Wk⇒ (tv₁ : TmVar) (k : EqKind)
               (Γ, Δ : Ctxt) (τ : Ty Γ) (ρ : Subst Γ Δ)
    :  (v : Γ ∋ τ) -> (σ : Ty Δ) -> (ρ⁻ : Subst⁻ tv₁ ρ) -> (tv₂ : TmVar)
    -> Tm⁻Eq k (v /∋⁻ wk⇒⁻ ρ⁻ σ) (v /∋⁻ ρ⁻ /⊢⁻ wk⁻ tv₂ σ)
  substVar⁻Wk⇒ {tv₁} v σ ρ⁻ tv₂ = coerceFromTm⁻ $
    substVar⁻Wk⇒' (weakCongˢ tv₁ tv₁) v ρ⁻ σ
      `transTm⁻`
    weakIsSubst⁻Wk _ (weakCongˢ₁₂₁ Var tv₁) (v /∋⁻ ρ⁻) σ
      `transTm⁻`
    substTm⁻Congˢ (reflTm⁻ $ v /∋⁻ ρ⁻) (wk⁻Cong $ reflTy _)

  substVar⁻VsLift (tv₁ : TmVar) (k : EqKind)
                  (Γ, Δ : Ctxt) (τ : Ty Γ) (ρ : Subst Γ Δ)
    :  (v : Γ ∋ τ) -> (σ : Ty Γ) -> (ρ⁻ : Subst⁻ tv₁ ρ) -> (tv₂ : TmVar)
    -> Tm⁻Eq k (vs v σ /∋⁻ ρ⁻ ↑⁻ σ) (v /∋⁻ ρ⁻ /⊢⁻ wk⁻ tv₂ (σ / ρ))
  substVar⁻VsLift v σ ρ⁻ tv₂ =
    castTm⁻Eq _ _ `transTm⁻` castTm⁻Eq _ _
      `transTm⁻`
    substVar⁻Wk⇒ v (σ / _) ρ⁻ tv₂

  subst⁻VsLift (k : EqKind) (tv₂ : TmVar)
               (Γ, Δ : Ctxt) (τ : Ty Γ) (ρ : Subst Γ Δ)
    :  (v : Γ ∋ τ) -> (σ : Ty Γ) -> (ρ⁻ : Subst⁻ tv₂ ρ)
    -> (tv₁, tv₃ : TmVar)
    -> Tm⁻Eq k (var⁻ tv₁ (vs v σ) /⊢⁻ ρ⁻ ↑⁻ σ)
               (var⁻ tv₁ v /⊢⁻ ρ⁻ /⊢⁻ wk⁻ tv₃ (σ / ρ))
  subst⁻VsLift v σ ρ⁻ tv₁ tv₃ =
    betweenTm⁻ (Tm⁻⊔Eq tv₁ _)
               (substTm⁻Congˢ (Tm⁻⊔Eq tv₁ _) (reflSubst⁻ _)) $
      substVar⁻VsLift v σ ρ⁻ tv₃

  substVar⁻Wk (k : EqKind) (Γ : Ctxt) (τ : Ty Γ)
    :  (tv : TmVar) -> (v : Γ ∋ τ) -> (σ : Ty Γ)
    -> Tm⁻Eq k (v /∋⁻ wk⁻ tv σ) (var⁻ tv (vs v σ))
  substVar⁻Wk tv v σ = coerceFromTm⁻ $
    symTm⁻ (Tm⁻⊔Eq _ _)
      `transTm⁻`
    symTm⁻ (weakIsSubst⁻Wk _ (weakCongˢ₁₂₁ Var tv) (var⁻ _ v) σ)
      `transTm⁻`
    weakIsVs _ _

  subst⁻Wk (k : EqKind) (Γ : Ctxt) (τ : Ty Γ)
    :  (tv₁, tv₂ : TmVar) -> (v : Γ ∋ τ) -> (σ : Ty Γ)
    -> Tm⁻Eq k (var⁻ tv₁ v /⊢⁻ wk⁻ tv₂ σ) (var⁻ tv₂ (vs v σ))
  subst⁻Wk tv₁ tv₂ v σ =
    Tm⁻⊔Eq _ _
      `transTm⁻`
    substVar⁻Wk tv₂ v σ

  substVar⁻VzSub (k : EqKind) (tv : TmVar)
                 (Γ : Ctxt) (σ : Ty Γ) (t : Γ ⊢ σ)
    : (t⁻ : Tm⁻ tv t) -> Tm⁻Eq k (vz σ /∋⁻ sub⁻ t⁻) t⁻
  substVar⁻VzSub t⁻ =
    castTm⁻Eq _ _ `transTm⁻` castTm⁻Eq _ _
                  `transTm⁻` castTm⁻Eq _ _

  subst⁻VzSub (k : EqKind) (tv : TmVar)
              (Γ : Ctxt) (σ : Ty Γ) (t : Γ ⊢ σ)
    :  (t⁻ : Tm⁻ tv t)
    -> Tm⁻Eq k (var⁻ tv (vz σ) /⊢⁻ sub⁻ t⁻) t⁻
  subst⁻VzSub t⁻ =
    Tm⁻⊔Eq _ _
      `transTm⁻`
    substVar⁻VzSub t⁻

  substVar⁻VsSub (tv₁ : TmVar) (k : EqKind)
                 (Γ : Ctxt) (τ, σ : Ty Γ) (t : Γ ⊢ σ)
    :  (tv₂ : TmVar) -> (v : Γ ∋ τ) -> (t⁻ : Tm⁻ tv₁ t)
    -> Tm⁻Eq k (vs v σ /∋⁻ sub⁻ t⁻) (var⁻ tv₂ v)
  substVar⁻VsSub tv₂ v t⁻ = coerceFromTm⁻ $
    castTm⁻Eq _ _ `transTm⁻` castTm⁻Eq _ _
      `transTm⁻`
    idVanishesVar⁻ v
      `transTm⁻`
    var⁻Cong (reflVar v)

  subst⁻VsSub (k : EqKind) (tv₁ : TmVar)
              (Γ : Ctxt) (τ : Ty Γ) (σ : Ty Γ) (t : Γ ⊢ σ)
    :  (tv₂ : TmVar) -> (v : Γ ∋ τ) -> (t⁻ : Tm⁻ tv₁ t)
    -> Tm⁻Eq k (var⁻ tv₂ (vs v σ) /⊢⁻ sub⁻ t⁻) (var⁻ tv₂ v)
  subst⁻VsSub tv₂ v t⁻ =
    Tm⁻⊔Eq _ _
      `transTm⁻`
    substVar⁻VsSub tv₂ v t⁻

Implicit-SubstitutionLemmas-SimpleLemmas : Type
Implicit-SubstitutionLemmas-SimpleLemmas =
  time-plugin(Implicit-SubstitutionLemmas-SimpleLemmas, Set)
