------------------------------------------------------------------------
-- Various lemmas
------------------------------------------------------------------------

-- # import Explicit
-- # import Implicit
-- # import Normalisation.NormalForms
-- # import Normalisation.NormalFormEquality
-- # import Normalisation.Values
-- # import Normalisation.ValueEquality

------------------------------------------------------------------------
-- Some congruences and well-formedness results

abstract

  wkValCong
    (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹) (v¹ : Val t¹) (σ¹ : Ty Γ¹)
    (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²) (v² : Val t²) (σ² : Ty Γ²)
    : v¹ ≈ˢ v² -> σ¹ ≛ σ² -> wkVal v¹ σ¹ ≈ˢ wkVal v² σ²
  wkValCong (castValEqˡ eqt eqv) eqσ = castValEqˡ _ $
    wkValCong eqv $ symTy (castTyEq _ _) `transTy` eqσ
  wkValCong (castValEqʳ eqt eqv) eqσ = castValEqʳ _ $
    wkValCong eqv $ eqσ `transTy` castTyEq _ _
  wkValCong (✶ValCong  eqat) eqσ =
    ✶ValCong  (substAtomCong eqat (wk⁻Cong eqσ))
  wkValCong (ElValCong eqat) eqσ =
    ElValCong (substAtomCong eqat (wk⁻Cong eqσ))
  wkValCong (ΠValCong eqt fCong) eqσ =
    ΠValCong (substTmCong eqt $ wkCong eqσ) $
      πCong $ \_ _ _ _ _ _ eqΓ' eqv₂ ->
        castValCong _ _ $
          applyΠCongruence fCong (Cong◅ʳ eqΓ') $
            castValCong _ _ eqv₂

  wkValWF (Γ : Ctxt) (τ : Ty Γ) (t : Γ ⊢ τ) (v : Val t)
    : WFVal v -> (σ : Ty Γ) -> WFVal (wkVal v σ)
  wkValWF (wfΠ {Γ} {τ₁} {τ₂} {t₁} {f}
               fCong (wkValCommutes fCommutes) (preservesWF fPres))
          σ =
    wfΠ (πCong $ \_ _ _ _ _ _ eqΓ' eqv₂ ->
           castValCong _ _ $
             applyΠCongruence fCong (Cong◅ʳ eqΓ') $
               castValCong _ _ eqv₂)
        (wkValCommutes $ \Γ' t₂ v₂ v₂wf τ ->
           castValEqˡ _
             (wkValCong (applyΠCongruence fCong
                           (reflRCtxt _)
                           (castValCong _ _ $ reflVal v₂wf))
                        (castTyCong _ _ $ reflTy τ))
             `transVal`
           fCommutes (σ ◅ʳ Γ') _ _
                     (wfCast v₂wf $ generalCastTmEq t₂ $
                                      symTy $ wk⋆SplitsˡTy τ₁ Γ')
                     (τ ∷✶ snoc++Is++Cons Γ')
             `transVal`
           castValEqʳ _
             (applyΠCongruence fCong
                (reflRCtxt (σ ◅ʳ Γ') ▻ʳCong castTyCong _ _ (reflTy τ))
                (castValCong _ _ $ castValCong _ _ $
                   wkValCong (reflVal v₂wf)
                             (castTyEqˡ _ $ castTyEqˡ _ $ reflTy τ))))
        (preservesWF $ \Γ' _ v₂ v₂wf ->
           wfCast (fPres _ _ _ (wfCast v₂wf _)) _)
  wkValWF (wfEl at)        σ = wfEl _
  wkValWF (wf✶  at)        σ = wf✶  _
  wkValWF (wfCast vwf eqt) σ = wfCast (wkValWF vwf (σ ∷✶ _)) _

  appˢCong (Γ¹ : Ctxt) (τ₁¹ : Ty Γ¹) (τ₂¹ : Ty (Γ¹ ▻ τ₁¹))
           (t₁¹ : Γ¹ ⊢ Π τ₁¹ τ₂¹) (t₂¹ : Γ¹ ⊢ τ₁¹)
           (v₁¹ : Val t₁¹) (v₂¹ : Val t₂¹)
           (Γ² : Ctxt) (τ₁² : Ty Γ²) (τ₂² : Ty (Γ² ▻ τ₁²))
           (t₁² : Γ² ⊢ Π τ₁² τ₂²) (t₂² : Γ² ⊢ τ₁²)
           (v₁² : Val t₁²) (v₂² : Val t₂²)
    : v₁¹ ≈ˢ v₁² -> v₂¹ ≈ˢ v₂² -> v₁¹ @ˢ v₂¹ ≈ˢ v₁² @ˢ v₂²
  appˢCong (ΠValCong eqt₁ fCong) eqv₂ = castValCong _ _ $
    applyΠCongruence fCong
                     (εʳCong $ tmEqCtxtEq eqt₁)
                     (castValCong _ _ eqv₂)
  appˢCong (castValEqˡ eqt eqv₁) eqv₂ with tmEqTyEq eqt =>
    _ (castValEqˡ eqt eqv₁) eqv₂ (ΠCong _ _) = castValEqˡ _ $
      appˢCong eqv₁ (castValEqˡ _ eqv₂)
  appˢCong (castValEqʳ eqt eqv₁) eqv₂ with tmEqTyEq eqt =>
    _ (castValEqʳ eqt eqv₁) eqv₂ (ΠCong _ _) = castValEqʳ _ $
      appˢCong eqv₁ (castValEqʳ _ eqv₂)

  appˢWF (Γ : Ctxt) (τ₁ : Ty Γ) (τ₂ : Ty (Γ ▻ τ₁))
         (t₁ : Γ ⊢ Π τ₁ τ₂) (t₂ : Γ ⊢ τ₁)
         (v₁ : Val t₁) (v₂ : Val t₂)
    : WFVal v₁ -> WFVal v₂ -> WFVal (v₁ @ˢ v₂)
  appˢWF (wfΠ {Γ} {τ₁} {τ₂} {t₁} {f}
              fCong (wkValCommutes fCommutes) (preservesWF fPres))
         v₂wf =
    wfCast (fPres (εʳ _) _ _ (wfCast v₂wf _)) _
  appˢWF (wfCast v₁wf eqt) v₂wf with tmEqTyEq eqt =>
    _ (wfCast v₁wf eqt) v₂wf (ΠCong _ _) =
      wfCast (appˢWF v₁wf (wfCast v₂wf _)) _

mutual

  reflect'Cong (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹) (at¹ : Atom t¹)
               (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²) (at² : Atom t²)
    :  (s¹ : Spine) -> (τs¹ : TySp s¹ τ¹)
    -> (s² : Spine) -> (τs² : TySp s² τ²)
    -> at¹ ≈⊨′ at²
    -> reflect' s¹ τs¹ at¹ ≈ˢ reflect' s² τs² at²
  reflect'Cong s¹ τs¹ s² τs² eqat₀ =
    helper s¹ τs¹ s² τs² eqat₀ (tmEqTyEq $ atomEqTmEq eqat₀)
    where
    abstract
      helper (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹) (at¹ : Atom t¹)
             (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²) (at² : Atom t²)
        :  (s¹ : Spine) -> (τs¹ : TySp s¹ τ¹)
        -> (s² : Spine) -> (τs² : TySp s² τ²)
        -> at¹ ≈⊨′ at² -> τ¹ ≛ τ²
        -> reflect' s¹ τs¹ at¹ ≈ˢ reflect' s² τs² at²
      helper ✶Sp  (✶TySp _)  ✶Sp  (✶TySp _)  eqat (✶Cong _)  =
        ✶ValCong eqat
      helper ElSp (ElTySp _) ElSp (ElTySp _) eqat (ElCong _) =
        ElValCong eqat
      helper (ΠSp s₁¹ s₂¹) (ΠTySp τs₁¹ τs₂¹)
             (ΠSp s₁² s₂²) (ΠTySp τs₁² τs₂²)
             eqat (ΠCong eqτ₁ eqτ₂) =
        ΠValCong (atomEqTmEq eqat) $
          πCong $ \_ _ _ _ _ _ eqΓ' eqv₂ ->
            reflect'Cong s₂¹ (τs₂¹ /Sp _ /Sp _)
                         s₂² (τs₂² /Sp _ /Sp _)
                         (app⊨Cong (substAtomCong eqat (wk⋆⁻Cong eqΓ'))
                                   (reify'Cong s₁¹ (τs₁¹ /Sp _)
                                               s₁² (τs₁² /Sp _)
                                               eqv₂))

  reify'Cong (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹) (v¹ : Val t¹)
             (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²) (v² : Val t²)
    :  (s¹ : Spine) -> (τs¹ : TySp s¹ τ¹)
    -> (s² : Spine) -> (τs² : TySp s² τ²)
    -> v¹ ≈ˢ v² -> reify' s¹ τs¹ v¹ ≈⊨ reify' s² τs² v²
  reify'Cong = helper
    where
    abstract
      helper (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹) (v¹ : Val t¹)
             (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²) (v² : Val t²)
        :  (s¹ : Spine) -> (τs¹ : TySp s¹ τ¹)
        -> (s² : Spine) -> (τs² : TySp s² τ²)
        -> v¹ ≈ˢ v²
        -> reify' s¹ τs¹ v¹ ≈⊨ reify' s² τs² v²
      helper s¹ τs¹ s² τs² (castValEqˡ eqt eqv) =
        symNF (generalCastNFEq _ _)
          `transNF`
        reify'Cong s¹ τs¹' s² τs² eqv
        where τs¹' = τs¹ ∷Sp symTy (tmEqTyEq eqt)
      helper s¹ τs¹ s² τs² (castValEqʳ eqt eqv) =
        reify'Cong s¹ τs¹ s² τs²' eqv
          `transNF`
        generalCastNFEq _ _
        where τs²' = τs² ∷Sp symTy (tmEqTyEq eqt)
      helper _ _ _ _ (✶ValCong  eqat) = ✶AtomCong  eqat
      helper _ _ _ _ (ElValCong eqat) = ElAtomCong eqat
      helper (ΠSp s₁¹ s₂¹) (ΠTySp τs₁¹ τs₂¹)
             (ΠSp s₁² s₂²) (ΠTySp τs₁² τs₂²)
             (ΠValCong eqt₁ fCong) = castNFCong _ _ $ λ⊨Cong $
        reify'Cong s₂¹ (τs₂¹ /Sp _ /Sp _)
                   s₂² (τs₂² /Sp _ /Sp _) $
          applyΠCongruence fCong
            (singletonʳCong eqτ₁) $
            castValCong _ _ $
              reflect'Cong s₁¹ (τs₁¹ /Sp _)
                           s₁² (τs₁² /Sp _) $
                           var⊨Cong $ vzCong eqτ₁
        where eqτ₁ = ΠEqLeftEq $ tmEqTyEq eqt₁

abstract

  reflectCong (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹) (at¹ : Atom t¹)
              (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²) (at² : Atom t²)
    : at¹ ≈⊨′ at² -> reflect at¹ ≈ˢ reflect at²
  reflectCong = reflect'Cong _ _ _ _

  reifyCong (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹) (v¹ : Val t¹)
            (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²) (v² : Val t²)
    : v¹ ≈ˢ v² -> reify v¹ ≈⊨ reify v²
  reifyCong = reify'Cong _ _ _ _

reflectWkCommutes (Γ : Ctxt) (τ : Ty Γ) (t : Γ ⊢ τ)
  :  (s : Spine) -> (τs : TySp s τ) -> (at : Atom t) -> (σ : Ty Γ)
  -> reflect' s (τs /Sp wk σ) (at /⊨′ wk⁻ Var σ) ≈ˢ
     wkVal (reflect' s τs at) σ

reifyWkCommutes (Γ : Ctxt) (τ : Ty Γ) (t : Γ ⊢ τ)
  :  (s : Spine) -> (τs : TySp s τ) -> (v : Val t) -> (σ : Ty Γ)
  -> reify' s (τs /Sp wk σ) (wkVal v σ) ≈⊨ reify' s τs v /⊨ wk⁻ Var σ

abstract

  reflect'WF (Γ : Ctxt) (τ : Ty Γ) (t : Γ ⊢ τ)
    :  (s : Spine) -> (τs : TySp s τ) -> (at : Atom t)
    -> WFVal (reflect' s τs at)
  reflect'WF ✶Sp         (✶TySp _)       at = wf✶  _
  reflect'WF ElSp        (ElTySp _)      at = wfEl _
  reflect'WF (ΠSp s₁ s₂) (ΠTySp τs₁ τs₂) at
    with reflect'Cong (ΠSp s₁ s₂) (ΠTySp τs₁ τs₂)
                      (ΠSp s₁ s₂) (ΠTySp τs₁ τs₂)
                      (reflAtom at) =>
    _  (ΠSp s₁ s₂) (ΠTySp τs₁ τs₂) at (ΠValCong _ f'Cong) =
      wfΠ f'Cong
          (wkValCommutes $ \Γ' t₂ v₂ v₂wf τ ->
             symVal (reflectWkCommutes s₂ (τs₂ /Sp _ /Sp _)
                                       ((at /⊨′ wk⋆⁻ Var Γ') @⊨
                                        reify' s₁ (τs₁ /Sp _) v₂)
                                       τ)
               `transVal`
             reflect'Cong s₂ (τs₂ /Sp _ /Sp _ /Sp _)
                          s₂ (τs₂ /Sp _ /Sp _)
               (castAtomEqˡ _ $ app⊨Cong
                  (symAtom (compSplitsAtom at (wk⋆⁻ Var Γ') (wk⁻ Var τ))
                     `transAtom`
                   substAtomCong (reflAtom at)
                                 (symSubst⁻ $ wk⋆⁻Splits Var _ _))
                  (symNF (reifyWkCommutes s₁ (τs₁ /Sp _) v₂ τ)
                     `transNF`
                   reify'Cong _ _ _ _ (reflVal $ wkValWF v₂wf τ)
                     `transNF`
                   generalCastNFEq _ _)))
          (preservesWF $ \Γ' _ v₂ v₂wf ->
             reflect'WF s₂ (τs₂ /Sp _ /Sp _) _)

  reflectWF (Γ : Ctxt) (τ : Ty Γ) (t : Γ ⊢ τ)
    : (at : Atom t) -> WFVal (reflect at)
  reflectWF = reflect'WF _ _

  valToTm⁻Cong (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹) (v¹ : Val t¹)
               (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²) (v² : Val t²)
    : v¹ ≈ˢ v² -> valToTm⁻ v¹ ≈⊢⁻ valToTm⁻ v²
  valToTm⁻Cong eqv = tmEqTm⁻Eq $ valEqTmEq eqv

  varToValCong (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (v¹ : Γ¹ ∋ τ¹)
               (Γ² : Ctxt) (τ² : Ty Γ²) (v² : Γ² ∋ τ²)
    : v¹ ≈∋ v² -> varToVal v¹ ≈ˢ varToVal v²
  varToValCong eqv = reflectCong $ var⊨Cong eqv

  varToValWF (Γ : Ctxt) (τ : Ty Γ)
    : (v : Γ ∋ τ) -> WFVal (varToVal v)
  varToValWF v = reflectWF (var⊨ v)
