------------------------------------------------------------------------
-- Value equality
------------------------------------------------------------------------

-- # import Explicit
-- # import Implicit
-- # import Normalisation.NormalForms
-- # import Normalisation.NormalFormEquality
-- # import Normalisation.Values

infix 40 ≈ˢ

------------------------------------------------------------------------
-- Value equality

  -- Note that this type has the same termination-related issues as
  -- Val.

mutual

  (≈ˢ) (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹)
       (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²)
    : Val t¹ -> Val t² -> Set
  (≈ˢ) = ValEq _ _ _ _ _ _

  data ValEq :  (Γ¹ : Ctxt) -> (τ¹ : Ty Γ¹) -> (t¹ : Γ¹ ⊢ τ¹)
             -> (Γ² : Ctxt) -> (τ² : Ty Γ²) -> (t² : Γ² ⊢ τ²)
             -> Val t¹ -> Val t² -> Set where

    -- Congruence.

    ✶ValCong (Γ¹ : Ctxt) (t¹ : Γ¹ ⊢ ✶ Γ¹) (at¹ : Atom t¹)
             (Γ² : Ctxt) (t² : Γ² ⊢ ✶ Γ²) (at² : Atom t²)
      : at¹ ≈⊨′ at² -> ✶Val at¹ ≈ˢ ✶Val at²
    ElValCong (Γ¹ : Ctxt) (t'¹ : Γ¹ ⊢ ✶ Γ¹) (t¹ : Γ¹ ⊢ El t'¹)
              (at¹ : Atom t¹)
              (Γ² : Ctxt) (t'² : Γ² ⊢ ✶ Γ²) (t² : Γ² ⊢ El t'²)
              (at² : Atom t²)
      : at¹ ≈⊨′ at² -> ElVal at¹ ≈ˢ ElVal at²
    ΠValCong (Γ¹ : Ctxt) (τ₁¹ : Ty Γ¹) (τ₂¹ : Ty (Γ¹ ▻ τ₁¹))
             (t₁¹ : Γ¹ ⊢ Π τ₁¹ τ₂¹) (f¹ : ΠFun t₁¹)
             (Γ² : Ctxt) (τ₁² : Ty Γ²) (τ₂² : Ty (Γ² ▻ τ₁²))
             (t₁² : Γ² ⊢ Π τ₁² τ₂²) (f² : ΠFun t₁²)
      : t₁¹ ≈⊢ t₁² -> ΠCongruence f¹ f² -> ΠVal f¹ ≈ˢ ΠVal f²

    -- Casts.

    castValEqˡ (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹) (v¹ : Val t¹)
               (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²) (v² : Val t²)
               (Γ³ : Ctxt) (τ³ : Ty Γ³) (t³ : Γ³ ⊢ τ³)
      : (eqt : t¹ ≈⊢ t³) -> v¹ ≈ˢ v² -> v¹ ∷ˢ eqt ≈ˢ v²
    castValEqʳ (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹) (v¹ : Val t¹)
               (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²) (v² : Val t²)
               (Γ³ : Ctxt) (τ³ : Ty Γ³) (t³ : Γ³ ⊢ τ³)
      : (eqt : t² ≈⊢ t³) -> v¹ ≈ˢ v² -> v¹ ≈ˢ v² ∷ˢ eqt

  data ΠCongruence
         {Γ¹ : Ctxt} {τ₁¹ : Ty Γ¹} {τ₂¹ : Ty (Γ¹ ▻ τ₁¹)}
         {t₁¹ : Γ¹ ⊢ Π τ₁¹ τ₂¹}
         {Γ² : Ctxt} {τ₁² : Ty Γ²} {τ₂² : Ty (Γ² ▻ τ₁²)}
         {t₁² : Γ² ⊢ Π τ₁² τ₂²}
         (f¹ : ΠFun t₁¹) (f² : ΠFun t₁²) : Set where
    πCong : (  (Γ'¹ : RCtxt Γ¹) -> (t₂¹ : Γ¹ ++ Γ'¹ ⊢ τ₁¹ / wk⋆ Γ'¹)
            -> (v₂¹ : Val t₂¹)
            -> (Γ'² : RCtxt Γ²) -> (t₂² : Γ² ++ Γ'² ⊢ τ₁² / wk⋆ Γ'²)
            -> (v₂² : Val t₂²)
            -> Γ'¹ ≜→ Γ'² -> v₂¹ ≈ˢ v₂²
            -> f¹ Γ'¹ t₂¹ v₂¹ ≈ˢ f² Γ'² t₂² v₂²)
          -> ΠCongruence f¹ f²

abstract

  applyΠCongruence (Γ¹ : Ctxt) (τ₁¹ : Ty Γ¹) (τ₂¹ : Ty (Γ¹ ▻ τ₁¹))
                   (t₁¹ : Γ¹ ⊢ Π τ₁¹ τ₂¹)
                   (Γ'¹ : RCtxt Γ¹) (t₂¹ : Γ¹ ++ Γ'¹ ⊢ τ₁¹ / wk⋆ Γ'¹)
                   (v₂¹ : Val t₂¹) (f¹ : ΠFun t₁¹)
                   (Γ² : Ctxt) (τ₁² : Ty Γ²) (τ₂² : Ty (Γ² ▻ τ₁²))
                   (t₁² : Γ² ⊢ Π τ₁² τ₂²)
                   (Γ'² : RCtxt Γ²) (t₂² : Γ² ++ Γ'² ⊢ τ₁² / wk⋆ Γ'²)
                   (v₂² : Val t₂²) (f² : ΠFun t₁²)
    :  ΠCongruence f¹ f² -> Γ'¹ ≜→ Γ'² -> v₂¹ ≈ˢ v₂²
    -> f¹ Γ'¹ t₂¹ v₂¹ ≈ˢ f² Γ'² t₂² v₂²
  applyΠCongruence (πCong fCong) = fCong _ _ _ _ _ _

------------------------------------------------------------------------
-- Well-formed values

  -- Some extra conditions that I place on values in order to be able
  -- to prove reflVal and wkValCommutes.

  -- Note that this type has the same termination-related issues as
  -- Val.

mutual

  WFVal (Γ : Ctxt) (τ : Ty Γ) (t : Γ ⊢ τ)
    : Val t -> Set
  WFVal = WFVal' _ _ _

  data WFVal' :  (Γ : Ctxt) -> (τ : Ty Γ) -> (t : Γ ⊢ τ)
              -> Val t -> Set where
    wfΠ (Γ : Ctxt) (τ₁ : Ty Γ) (τ₂ : Ty (Γ ▻ τ₁)) (t₁ : Γ ⊢ Π τ₁ τ₂)
        (f : ΠFun t₁)
      :  ΠCongruence f f -> WkValCommutes f -> PreservesWF f
      -> WFVal (ΠVal f)
    wfEl (Γ : Ctxt) (t' : Γ ⊢ ✶ Γ) (t : Γ ⊢ El t')
      : (at : Atom t) -> WFVal (ElVal at)
    wf✶ (Γ : Ctxt) (t : Γ ⊢ ✶ Γ)
      : (at : Atom t) -> WFVal (✶Val at)
    wfCast (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹)
           (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²)
           (v : Val t¹)
      : WFVal v -> (eqt : t¹ ≈⊢ t²) -> WFVal (v ∷ˢ eqt)

  data WkValCommutes {Γ : Ctxt} {τ₁ : Ty Γ} {τ₂ : Ty (Γ ▻ τ₁)}
                     {t₁ : Γ ⊢ Π τ₁ τ₂}
                     (f : ΠFun t₁) : Set where
    wkValCommutes
      : (  (Γ' : RCtxt Γ) -> (t₂ : Γ ++ Γ' ⊢ τ₁ / wk⋆ Γ')
        -> (v₂ : Val t₂) -> WFVal v₂ -> (σ : Ty (Γ ++ Γ'))
        -> wkVal (f Γ' t₂ v₂) σ ≈ˢ
           f (Γ' ▻ʳ σ)
             (t₂ /⊢ wk σ ∷≡⊢ symTy (compSplitsTy τ₁ (wk⋆ Γ') (wk σ)))
             (wkVal v₂ σ ∷ˢ symTm (castTmEq _ _)))
        -> WkValCommutes f

  data PreservesWF {Γ : Ctxt} {τ₁ : Ty Γ} {τ₂ : Ty (Γ ▻ τ₁)}
                   {t₁ : Γ ⊢ Π τ₁ τ₂}
                   (f : ΠFun t₁) : Set where
    preservesWF
      : (  (Γ' : RCtxt Γ) -> (t₂ : Γ ++ Γ' ⊢ τ₁ / wk⋆ Γ')
        -> (v₂ : Val t₂)
        -> WFVal v₂ -> WFVal (f Γ' t₂ v₂))
        -> PreservesWF f

------------------------------------------------------------------------
-- Convenient lemma

abstract

  castValCong
    (Γ₁¹ : Ctxt) (τ₁¹ : Ty Γ₁¹) (t₁¹ : Γ₁¹ ⊢ τ₁¹) (v¹ : Val t₁¹)
    (Γ₂¹ : Ctxt) (τ₂¹ : Ty Γ₂¹) (t₂¹ : Γ₂¹ ⊢ τ₂¹)
    (Γ₁² : Ctxt) (τ₁² : Ty Γ₁²) (t₁² : Γ₁² ⊢ τ₁²) (v² : Val t₁²)
    (Γ₂² : Ctxt) (τ₂² : Ty Γ₂²) (t₂² : Γ₂² ⊢ τ₂²)
    :  (eqt¹ : t₁¹ ≈⊢ t₂¹) -> (eqt² : t₁² ≈⊢ t₂²)
    -> v¹ ≈ˢ v² -> v¹ ∷ˢ eqt¹ ≈ˢ v² ∷ˢ eqt²
  castValCong _ _ eqv = castValEqˡ _ (castValEqʳ _ eqv)

------------------------------------------------------------------------
-- Equal values have equal indices

abstract

  valEqTmEq (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹) (v¹ : Val t¹)
            (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²) (v² : Val t²)
    : v¹ ≈ˢ v² -> t¹ ≈⊢ t²
  valEqTmEq (✶ValCong eqat)       = atomEqTmEq eqat
  valEqTmEq (ElValCong eqat)      = atomEqTmEq eqat
  valEqTmEq (ΠValCong eqt₁ fCong) = eqt₁
  valEqTmEq (castValEqˡ eqt eqv)  = symTm eqt `transTm` valEqTmEq eqv
  valEqTmEq (castValEqʳ eqt eqv)  = valEqTmEq eqv `transTm` eqt

------------------------------------------------------------------------
-- (≈ˢ) is a partial equivalence relation

-- It is an equivalence relation for well-formed values.

abstract

  reflVal (Γ : Ctxt) (τ : Ty Γ) (t : Γ ⊢ τ) (v : Val t)
    : WFVal v -> v ≈ˢ v
  reflVal (wf✶  at)        = ✶ValCong  $ reflAtom at
  reflVal (wfEl at)        = ElValCong $ reflAtom at
  reflVal (wfΠ fCong _ _)  = ΠValCong (reflTm _) fCong
  reflVal (wfCast wfv eqt) = castValCong eqt eqt $ reflVal wfv

  -- Convenient lemma.

  castValEq (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹)
            (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²)
            (v : Val t¹)
    : WFVal v -> (eqt : t¹ ≈⊢ t²) -> v ∷ˢ eqt ≈ˢ v
  castValEq wfv eqt = castValEqˡ eqt (reflVal wfv)

  symVal (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹) (v¹ : Val t¹)
         (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²) (v² : Val t²)
    : v¹ ≈ˢ v² -> v² ≈ˢ v¹
  symVal = symVal' _ (tyToTySp _) _ (tyToTySp _)
    where
    symVal' (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹) (v¹ : Val t¹)
            (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²) (v² : Val t²)
      :  (s¹ : Spine) -> (τs¹ : TySp s¹ τ¹)
      -> (s² : Spine) -> (τs² : TySp s² τ²)
      -> v¹ ≈ˢ v² -> v² ≈ˢ v¹
    symVal' _ _ _ _ (✶ValCong eqat)  = ✶ValCong  (symAtom eqat)
    symVal' _ _ _ _ (ElValCong eqat) = ElValCong (symAtom eqat)
    symVal' (ΠSp s₁¹ s₂¹) (ΠTySp τs₁¹ τs₂¹)
            (ΠSp s₁² s₂²) (ΠTySp τs₁² τs₂²)
            (ΠValCong eqt₁ fCong) = ΠValCong (symTm eqt₁) $ πCong $
      \_ _ _ _ _ _ eqΓ' eqv ->
         symVal' s₂¹ (τs₂¹ /Sp _ /Sp _)
                 s₂² (τs₂² /Sp _ /Sp _) $
           applyΠCongruence fCong
                            (symRCtxt eqΓ')
                            (symVal' s₁² (τs₁² /Sp _)
                                     s₁¹ (τs₁¹ /Sp _)
                                     eqv)
    symVal' s¹ τs¹ s² τs² (castValEqˡ eqt eqv) =
      castValEqʳ eqt (symVal' s¹ τs¹' s² τs² eqv)
      where τs¹' = τs¹ ∷Sp symTy (tmEqTyEq eqt)
    symVal' s¹ τs¹ s² τs² (castValEqʳ eqt eqv) =
      castValEqˡ eqt (symVal' s¹ τs¹ s² τs²' eqv)
      where τs²' = τs² ∷Sp symTy (tmEqTyEq eqt)

  transVal (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹) (v¹ : Val t¹)
           (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²) (v² : Val t²)
           (Γ³ : Ctxt) (τ³ : Ty Γ³) (t³ : Γ³ ⊢ τ³) (v³ : Val t³)
    : v¹ ≈ˢ v² -> v² ≈ˢ v³ -> v¹ ≈ˢ v³
  transVal eqv¹² eqv²³ = transVal' _ (tyToTySp _)
                                   _ (tyToTySp _)
                                   _ (tyToTySp _)
                                   eqv¹² eqv²³
    where
    transVal' (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹) (v¹ : Val t¹)
              (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²) (v² : Val t²)
              (Γ³ : Ctxt) (τ³ : Ty Γ³) (t³ : Γ³ ⊢ τ³) (v³ : Val t³)
      :  (s¹ : Spine) -> (τs¹ : TySp s¹ τ¹)
      -> (s² : Spine) -> (τs² : TySp s² τ²)
      -> (s³ : Spine) -> (τs³ : TySp s³ τ³)
      -> v¹ ≈ˢ v² -> v² ≈ˢ v³ -> v¹ ≈ˢ v³
    transVal' s¹ τs¹ s² τs² s³ τs³ (castValEqˡ eqt eqv¹) eqv² =
      castValEqˡ eqt (transVal' s¹ τs¹' s² τs² s³ τs³ eqv¹ eqv²)
      where τs¹' = τs¹ ∷Sp symTy (tmEqTyEq eqt)
    transVal' s¹ τs¹ s² τs² s³ τs³ eqv¹ (castValEqʳ eqt eqv²) =
      castValEqʳ eqt (transVal' s¹ τs¹ s² τs² s³ τs³' eqv¹ eqv²)
      where τs³' = τs³ ∷Sp symTy (tmEqTyEq eqt)
    transVal' s¹ τs¹ s² τs² s³ τs³
           (castValEqʳ eqt eqv₁) (castValEqˡ eqt eqv₂) =
      transVal' s¹ τs¹ s² τs²' s³ τs³ eqv₁ eqv₂
      where τs²' = τs² ∷Sp symTy (tmEqTyEq eqt)
    transVal' _ _ _ _ _ _ (✶ValCong eqat¹²) (✶ValCong eqat²³) =
      ✶ValCong (transAtom eqat¹² eqat²³)
    transVal' _ _ _ _ _ _ (ElValCong eqat¹²) (ElValCong eqat²³) =
      ElValCong (transAtom eqat¹² eqat²³)
    transVal' {Γ¹} {Π τ₁¹ τ₂¹} {t₁¹} {ΠVal f¹}
              {Γ²} {Π τ₁² τ₂²} {t₁²} {ΠVal f²}
              {Γ³} {Π τ₁³ τ₂³} {t₁³} {ΠVal f³}
              (ΠSp s₁¹ s₂¹) (ΠTySp τs₁¹ τs₂¹)
              (ΠSp s₁² s₂²) (ΠTySp τs₁² τs₂²)
              (ΠSp s₁³ s₂³) (ΠTySp τs₁³ τs₂³)
              (ΠValCong eqt₁¹² fCong¹²) (ΠValCong eqt₁²³ fCong²³) =
      ΠValCong (transTm eqt₁¹² eqt₁²³) $ πCong $
        \Γ'¹ t₂¹ v₂¹ Γ'³ t₂³ v₂³ eqΓ'¹³ eqv¹³ ->
           let abstract
                 eqΓ¹² : Γ¹ ≜ Γ²
                 eqΓ¹² = tmEqCtxtEq eqt₁¹²

               Γ'² : RCtxt Γ²
               Γ'² = Γ'¹ ∷→ eqΓ¹²

               abstract
                 eqΓ'¹² : Γ'¹ ≜→ Γ'²
                 eqΓ'¹² = castRCtxtEq Γ'¹ eqΓ¹²
                 eqΓ'²³ : Γ'² ≜→ Γ'³
                 eqΓ'²³ = symRCtxt eqΓ'¹² `transRCtxt` eqΓ'¹³
                 lemma₁ : τ₁¹ / wk⋆ Γ'¹ ≛ τ₁² / wk⋆ Γ'²
                 lemma₁ = substTyCong (ΠEqLeftEq $ tmEqTyEq eqt₁¹²)
                                      (wk⋆Cong eqΓ'¹²)

               t₂² : Γ² ++ Γ'² ⊢ τ₁² / wk⋆ Γ'²
               t₂² = t₂¹ ∷⊢ lemma₁

               abstract
                 lemma₂ : t₂¹ ≈⊢ t₂²
                 lemma₂ = generalCastTmEq _ _

               v₂² : Val t₂²
               v₂² = v₂¹ ∷ˢ lemma₂

               abstract
                 eqv¹¹ : v₂¹ ≈ˢ v₂¹
                 eqv¹¹ = transVal' s₁¹ (τs₁¹ /Sp _)
                                   s₁³ (τs₁³ /Sp _)
                                   s₁¹ (τs₁¹ /Sp _)
                                   eqv¹³
                                   (symVal eqv¹³)
                 eqv¹² : v₂¹ ≈ˢ v₂²
                 eqv¹² = castValEqʳ lemma₂ eqv¹¹
                 eqv²³ : v₂² ≈ˢ v₂³
                 eqv²³ = transVal' s₁¹ (τs₁¹ /Sp _ ∷Sp tmEqTyEq lemma₂)
                                   s₁¹ (τs₁¹ /Sp _)
                                   s₁³ (τs₁³ /Sp _)
                                   (symVal eqv¹²)
                                   eqv¹³
           in
           transVal' s₂¹ (τs₂¹ /Sp _ /Sp _)
                     s₂² (τs₂² /Sp _ /Sp _)
                     s₂³ (τs₂³ /Sp _ /Sp _)
                     (applyΠCongruence fCong¹² eqΓ'¹² eqv¹²)
                     (applyΠCongruence fCong²³ eqΓ'²³ eqv²³)

  -- Another convenient lemma.

  betweenVal (Γ₁ : Ctxt) (τ₁ : Ty Γ₁) (t₁ : Γ₁ ⊢ τ₁) (v₁ : Val t₁)
             (Γ₂ : Ctxt) (τ₂ : Ty Γ₂) (t₂ : Γ₂ ⊢ τ₂) (v₂ : Val t₂)
             (Γ₃ : Ctxt) (τ₃ : Ty Γ₃) (t₃ : Γ₃ ⊢ τ₃) (v₃ : Val t₃)
             (Γ₄ : Ctxt) (τ₄ : Ty Γ₄) (t₄ : Γ₄ ⊢ τ₄) (v₄ : Val t₄)
    : v₁ ≈ˢ v₂ -> v₄ ≈ˢ v₃ -> v₂ ≈ˢ v₃ -> v₁ ≈ˢ v₄
  betweenVal eq₁ eq₃ eq₂ = eq₁ `transVal` eq₂ `transVal` symVal eq₃

Normalisation-ValueEquality : Type
Normalisation-ValueEquality =
  time-plugin(Normalisation-ValueEquality, Set)
